"""
LSP server offering code actions to generate function implementations
using OpenAI's Codex machine learning model.
"""

import logging

from pathlib import Path
from typing import List

from asts import AST, ASTLanguage, FunctionAST, RootAST
from kitchensink.utility.pygls import NonTerminatingLanguageServerProtocol
from kitchensink.utility.server import lsp_arg_parser
from pygments.lexers import guess_lexer, PythonLexer
from pygls.lsp.methods import CODE_ACTION
from pygls.lsp.types import CodeActionParams, Command, Range
from pygls.workspace import Document
from pygls.server import LanguageServer

from function_generator.arguments import ArgParseRange
from function_generator.ast_utils import (
    asts_in_range,
    find_function,
    function_body_without_docstring,
    function_docstring,
    function_prototype,
    qualified_name,
)
from function_generator.model import CodexModel, CachingCodexModel
from function_generator.lsp import function_edit, range_to_tuple

DEFAULT_PORT = 3130
DEFAULT_STDIO_FLAG = False


def main():
    # Setup and parse arguments.
    parser = lsp_arg_parser(
        desc=__doc__,
        default_port=DEFAULT_PORT,
        default_stdio_flag=DEFAULT_STDIO_FLAG,
    )
    parser.add_argument(
        "--engine",
        type=str,
        default=CodexModel.DEFAULT_ENGINE,
        choices=CodexModel.DEFAULT_ENGINE_CHOICES,
        help="Codex engine to utilize in generation.",
    )
    parser.add_argument(
        "--temperature",
        type=float,
        default=CodexModel.DEFAULT_TEMPERATURE,
        choices=ArgParseRange(0.0, 1.0),
        help="Sampling temperature to use; higher values imply model taking more risk.",
    )
    parser.add_argument(
        "--top-p",
        type=float,
        default=CodexModel.DEFAULT_TOP_P,
        choices=ArgParseRange(0.0, 1.0),
        help="Nucleus sampling; model considers tokens with top_p probability mass.",
    )
    parser.add_argument(
        "--max-tokens",
        type=int,
        default=CodexModel.DEFAULT_MAX_TOKENS,
        choices=ArgParseRange(64, 2048),
        help="Number of tokens to generate in each completion requst.",
    )
    parser.add_argument(
        "--log-level",
        type=str,
        default="INFO",
        choices=["DEBUG", "INFO", "WARNING", "ERROR", "CRITICAL"],
        help="Verbosity of logging messages.",
    )

    args = parser.parse_args()
    logging.basicConfig(
        format="%(asctime)s.%(msecs)03d %(levelname)s: %(message)s",
        level=getattr(logging, args.log_level),
        datefmt="%Y-%m-%d %H:%M:%S",
    )
    model = CachingCodexModel(
        engine=args.engine,
        temperature=args.temperature,
        top_p=args.top_p,
        max_tokens=args.max_tokens,
    )

    # Create the Language server.
    if args.stdio:
        server = LanguageServer()
    else:
        server = LanguageServer(protocol_cls=NonTerminatingLanguageServerProtocol)

    @server.feature(CODE_ACTION)
    def codeactions(params: CodeActionParams) -> List[Command]:
        def is_python_document(document: Document) -> bool:
            """
            Return true if DOCUMENT is python language.
            """
            if Path(document.uri).suffix == ".py":
                return True
            if isinstance(guess_lexer(document.source), PythonLexer):
                return True
            return False

        def is_vscode_edit_pane(document: Document) -> bool:
            """
            Return true if DOCUMENT is a read-only VSCode refactoring edit pane.
            """
            return document.uri.startswith("vscode-bulkeditpreview")

        def selected_named_functions(
            script: RootAST,
            selected: Range,
        ) -> List[FunctionAST]:
            """
            Return the named functions in SCRIPT overlapping the
            SELECTED range.
            """
            asts = asts_in_range(script, range_to_tuple(selected))
            functions = [a for a in asts if isinstance(a, FunctionAST)]
            functions = [f for f in functions if f.function_name()]
            return functions

        def should_generate_function_implementation(function: FunctionAST) -> bool:
            """
            Return TRUE if we should create a code action to generate a
            implementation for FUNCTION.  If FUNCTION has a documentation
            string, an implementation may be generated by Codex.
            """
            return function_docstring(function) is not None

        workspace = server.workspace
        uri = params.text_document.uri
        document = workspace.get_document(uri)
        commands = []

        if is_python_document(document) and not is_vscode_edit_pane(document):
            script = AST.from_string(document.source, ASTLanguage.Python)
            functions = selected_named_functions(script, params.range)

            for function in functions:
                if should_generate_function_implementation(function):
                    fname = qualified_name(script, function)
                    if not function_body_without_docstring(function):
                        title = "Create function implementation @%s" % fname
                    else:
                        title = "Update function implementation @%s" % fname

                    command = Command(
                        title=title,
                        command="codex_function_implementation",
                        arguments=[document.uri, fname],
                    )
                    commands.append(command)

        return commands

    @server.command("codex_function_implementation")
    def codex_function_implementation(cmd_args):
        """
        Generate and insert/replace a function implementation using the
        OpenAI Codex model for the function given in CMD_ARGS.
        """

        # Get the uri, function name from the command arguments.
        uri, fname = cmd_args

        # Find the function we need to generate an implementation for.
        document = server.workspace.get_document(uri)
        script = AST.from_string(document.source, ASTLanguage.Python)
        function = find_function(script, fname)

        # Generate the implementation for the function using the Codex model.
        prototype = function_prototype(function)
        completion = model.query(document.uri, script, prototype)

        # If a function could be generated, create and apply the
        # workspace edit.
        if completion:
            edit = function_edit(document, script, fname, completion)
            if edit:
                server.apply_edit(edit)
            else:
                server.show_message(f"@{fname} - no changes to current implementation.")
        else:
            server.show_message(f"@{fname} - implementation could not be generated.")

    # Spawn the server.
    if args.stdio:
        server.start_io()
    else:
        server.start_tcp("0.0.0.0", args.port)


if __name__ == "__main__":
    main()
